/****   request.js   ****/
// 导入axios
import axios from 'axios'
// 使用element-ui Message做消息提醒
import { Message } from 'element-ui';
import Cookies from 'js-cookie'
//1. 创建新的axios实例，
const service = axios.create({
    // 公共接口--这里注意后面会讲
    baseURL: process.env.BASE_API,
    // 超时时间 单位是ms，这里设置了3s的超时时间
    timeout: 5 * 1000
})
// 2.请求拦截器
service.interceptors.request.use(config => {
    //发请求前做的一些处理，数据转化，配置请求头，设置token,设置loading等，根据需求去添加
    config.data = JSON.stringify(config.data); //数据转化,也可以使用qs转换
    // config.headers = {
    //     'Content-Type': 'application/json' //配置请求头
    // }
    // config.headers = { 'Content-Type': 'application/x-www-form-urlencoded' } //配置请求头
    //如有需要：注意使用token的时候需要引入cookie方法或者用本地localStorage等方法，推荐js-cookie
    // const token = Cookies.get('cook');//这里取token之前，你肯定需要先拿到token,存一下
    // if (token) {
    //     // config.params = { 'admin_token': token } //如果要求携带在参数中
    //     // config.headers['admin_token'] = token; //如果要求携带在请求头中
    //     // config.headers['admin-token'] = token; //如果要求携带在请求头中
    // }


    return config
}, error => {
    Promise.reject(error)
})



// 3.响应拦截器
service.interceptors.response.use(response => {
    //接收到响应数据并成功后的一些共有的处理，关闭loading等

    return response.data
}, error => {
    /***** 接收到异常响应的处理开始 *****/
    if (error && error.response) {
        // 1.公共错误处理
        // 2.根据响应码具体处理
        switch (error.response.status) {
            case 10000:
                error.message = '系统未知异常'
                break;
            case 10001:
                error.message = '请求方法不支持'
                break;
            case 10002:
                error.message = '缺少必要的请求头'
                break;
            case 10003:
                error.message = '无效的token'
                // window.location.href = "/NotFound"
                break;
            case 10004:
                error.message = 'token为空'
                break;
            case 10005:
                error.message = '管理员登录失败'
                break;
            case 10006:
                error.message = '权限不足'
                break;
            case 11001:
                error.message = '参数格式校验失败'
                break;
            case 11002:
                error.message = 'body为空'
                break;
            case 11003:
                error.message = '参数异常'
                break;
            case 11004:
                error.message = '重复提交表单'
                break;
            case 11005:
                error.message = '订单提交失败'
                break;
            case 11006:
                error.message = '消费者消费异常'
                break;
            case 11007:
                error.message = '第三方服务调用失败'
                break;
            case 11008:
                error.message = '农商行订单状态查询失败'
                break;
            case 16000:
                error.message = '数据已存在'
                break;
            case 16000:
                error.message = '数据不存在'
                break;
            case 16006:
                error.message = '临时文件不存在'
                break;
            case 16007:
                error.message = '文件上传失败'
                break;
            case 16008:
                error.message = '文件太大'
                break;

            default:
                error.message = `连接错误${error.response.status}`
        }
    } else {
        // 超时处理
        if (JSON.stringify(error).includes('timeout')) {
            Message.error('服务器响应超时，请刷新当前页')
        }
        error.message = '连接服务器失败'
    }

    Message.error(error.message)
    /***** 处理结束 *****/
    //如果不需要错误处理，以上的处理过程都可省略
    return Promise.resolve(error.response)
})
//4.导入文件
export default service
